/**
 * Created by bcole on 12/5/14.
 */

var gameState;
var gameState_titleScreen = 0;
var gameState_game = 1;
var gameState_preGame = 2;
var gameState_gameOver_setup = 3;
var gameState_gameOver_wait = 4;
var gameState_gameOver = 5;
var gameState_cleanUp = 6;
var gameState_postCleanup = 7;

var game = {};
var scale = 3;//5
var pixel = { scale: scale, canvas: null, context: null, width: 0, height: 0 }


var currentScore = 0;
var currentScoreDisplay = 0;
var highScore = 0;

//game objects
var player;
var cealing = [];
var spikes = [];
cealingAt = 0;

var fallingBrickTypes = [];

//show blocks destoyed!
var blips = [];


var speed = 1;
var jumpButton;
var leftButton;
var rightButton;
var actionButton;

var blocksGroup;
var spikesGroup;

var spacesX;
var spacesY;
var gameSizeX;
var gameSizeY;
var unitSize;

var playerMaterial;
var blockMaterial;

var leftDown = false;
var rightDown = false;
var jumpDown = false;

var deleteQueue = [];
var runSpawaner = true;
var jumpTimer = 0;
var jumpReleased = true;

var playerStartX;
var playerStartY;

var gameGroup;

$(document).ready(function(){

    $(window).focus(function () {
       runSpawaner = true;
    }).blur(function () {
       runSpawaner = false;
    });

    //when jquery is ready
    //... do we even need jquery?
    gameSizeX = 1280 / 5;
    gameSizeY = 720 / 5;
    unitSize = 8;

    game = new Phaser.Game(gameSizeX, gameSizeY, Phaser.CANVAS, '',
        { init: init, preload: preload, create: create, update: update, render: render },
        false, false, null);


    //these are spaces we occupy
    spacesX = Math.floor(gameSizeX/unitSize); //is 8 our unit size?
    spacesY = Math.floor(gameSizeY/unitSize);
})

function init(){

    gameState = gameState_titleScreen;

    //scaling shit!
        //  Hide the un-scaled game canvas
        game.canvas.style['display'] = 'none';

        //  Create our scaled canvas. It will be the size of the game * whatever scale value you've set
        pixel.canvas = Phaser.Canvas.create(game.width * pixel.scale, game.height * pixel.scale);

        //  Store a reference to the Canvas Context
        pixel.context = pixel.canvas.getContext('2d');

        //  Add the scaled canvas to the DOM
        Phaser.Canvas.addToDOM(pixel.canvas);

        //  Disable smoothing on the scaled canvas
        Phaser.Canvas.setSmoothingEnabled(pixel.context, false);

        //  Cache the width/height to avoid looking it up every render
        pixel.width = pixel.canvas.width;
        pixel.height = pixel.canvas.height;
    // end scaling shit!

    //set up buttons
    jumpButton = game.input.keyboard.addKey(Phaser.Keyboard.UP);
    leftButton = game.input.keyboard.addKey(Phaser.Keyboard.LEFT);
    rightButton = game.input.keyboard.addKey(Phaser.Keyboard.RIGHT);
    actionButton = game.input.keyboard.addKey(Phaser.Keyboard.SPACEBAR);

    //set up "shapes".  These are just tests right now
    var crossBlock =            [3,3,[
                                  0,1,0,
                                  1,1,1,
                                  0,1,0], 'redBrick',1];

    var straightBlock =     [4,1,[1,1,1,1], 'greenBrick',2];

    var lBlock =            [3,3,[1,0,0,
                                  1,1,1], 'blueBrick',3];

    var squareBlock =       [2,2,[1,1,
                                  1,1], 'orangeBrick',4];

    var tBlock =            [3,3,[0,1,0,
                                  1,1,1], 'purpleBrick',5];



    fallingBrickTypes = [crossBlock, straightBlock, squareBlock, tBlock, lBlock];
}

var blockSpawnIn;
var FallingCealing;
var Jump;
var killBlock;
var playerHit;
var levelClear;
function preload(){
    game.load.spritesheet('player', 'assets/sprites/player.png', 8, 16, 1);

    game.load.spritesheet('redBrick', 'assets/sprites/redBrick.png', 8, 8, 1);
    game.load.spritesheet('greenBrick', 'assets/sprites/greenBrick.png', 8, 8, 1);
    game.load.spritesheet('blueBrick', 'assets/sprites/blueBrick.png', 8, 8, 1);
    game.load.spritesheet('orangeBrick', 'assets/sprites/orangeBrick.png', 8, 8, 1);
    game.load.spritesheet('purpleBrick', 'assets/sprites/purpleBrick.png', 8, 8, 1);
    game.load.spritesheet('blackBrick', 'assets/sprites/blackBrick.png', 8, 8, 1);
    game.load.spritesheet('empty', 'assets/sprites/empty.png', 8, 8, 1);

    game.load.spritesheet('redPeg', 'assets/sprites/redPeg.png', 8, 8, 1);
    game.load.spritesheet('greenPeg', 'assets/sprites/greenPeg.png', 8, 8, 1);
    game.load.spritesheet('bluePeg', 'assets/sprites/bluePeg.png', 8, 8, 1);
    game.load.spritesheet('orangePeg', 'assets/sprites/orangePeg.png', 8, 8, 1);
    game.load.spritesheet('purplePeg', 'assets/sprites/purplePeg.png', 8, 8, 1);

    game.load.spritesheet('spikeUp', 'assets/sprites/spike.png', 8, 8, 1);
    game.load.spritesheet('spikeDown', 'assets/sprites/spike_down.png', 8, 8, 1);


    //font
    game.load.image('undo_100', 'assets/editUndo_font100.png');
    game.load.image('undo_200', 'assets/editUndo_font200.png');

    game.load.image('undo_50', 'assets/editUndo_font50.png');

    game.load.audio('blockSpawnIn', 'assets/sounds/blockSpawnIn.wav');
    game.load.audio('FallingCealing', 'assets/sounds/fallingCealing.wav');
    game.load.audio('Jump', 'assets/sounds/Jump3.wav');
    game.load.audio('killBlock', 'assets/sounds/killBlock.wav');
    game.load.audio('playerHit', 'assets/sounds/playerHit.wav');
    game.load.audio('levelClear', 'assets/sounds/levelClear.wav');

}

function create(){

    blockSpawnIn = game.add.audio('blockSpawnIn');
    FallingCealing = game.add.audio('FallingCealing');
    Jump = game.add.audio('Jump');
    killBlock = game.add.audio('killBlock');
    playerHit = game.add.audio('playerHit');
    levelClear = game.add.audio('levelClear');

    killBlock.allowMultiple = true;

    //set up groups
    gameGroup = game.add.group();
    blocksGroup = game.add.group(gameGroup);

    playerStartX = 2;
    playerStartY = 13;

    game.world.setBounds(0, 0, gameSizeX, gameSizeY);

    game.physics.startSystem(Phaser.Physics.P2JS);
    //  Turn on impact events for the world, without this we get no collision callbacks
    game.physics.p2.setImpactEvents(true);
    //  Set the world (global) gravity
    game.physics.p2.gravity.y = 300;

    playerMaterial = game.physics.p2.createMaterial('playerMaterial');
    blockMaterial = game.physics.p2.createMaterial('blockMaterial');
    var combineMaterial_player_block = setupMaterial(playerMaterial, blockMaterial, 0.0, 0.0, 0.0, 1000, 0.0, 100, 0);
    var combineMaterial_block_block = setupMaterial(blockMaterial, blockMaterial, 10.0, 0.5, 1e7, 3, 1000, 0, 0);

    createPlayfield();
    addMainMenu();
    setupTimedSpawning();
}

var scoreText;
var gameOver_title;
var gameOver_score;
var gameOver_highScore;
var gameOver_instructions;

var title_image;
var instructions_image;
var score_image;
var gameOver_title_image;
var gameOver_score_image;
var gameOver_highScore_image;
var gameOver_instructions_image;

function addMainMenu(){
    var title;
    var instructions;

    title = game.add.retroFont('undo_100', 12, 16, Phaser.RetroFont.TEXT_SET1, 10, 0, 0);
    title.text = "-CHAMBER-";

    title_image = game.add.image(game.world.centerX, game.world.centerY-20, title);
    title_image.anchor.set(0.5, 1);

    instructions = game.add.retroFont('undo_50', 6, 8, Phaser.RetroFont.TEXT_SET1, 10, 0, 0);
    instructions.multiLine = true;
    instructions.text = "use arrow keys : up to jump\n  match up colored blocks\n\n        ( press up )   ";

    instructions_image = game.add.image(game.world.centerX, game.world.centerY+15, instructions);
    instructions_image.anchor.set(0.5, 1);

    scoreText = game.add.retroFont('undo_100', 12, 16, Phaser.RetroFont.TEXT_SET1, 10, 0, 0);

    score_image = game.add.image(game.world.width-10, 16, scoreText);
    //score_image.tint = 0xA2F3E4;
    score_image.anchor.set(1, 0.5);
}


var gameOverDisplayTimer;
var highScoreCounter;

function addGameOverText(){
    gameOver_title = game.add.retroFont('undo_200', 24, 32, Phaser.RetroFont.TEXT_SET1, 10, 0, 0);
    gameOver_title.text = "GAMEOVER";
        gameOver_title_image = game.add.image(game.world.centerX, game.world.centerY-20, gameOver_title);
        gameOver_title_image.anchor.set(0.5, 1);



    gameOver_score = game.add.retroFont('undo_100', 12, 16, Phaser.RetroFont.TEXT_SET1, 10, 0, 0);
    gameOver_score.multiLine = true;
    gameOver_score.text = "score:\n"+currentScore;
        gameOver_score_image = game.add.image(game.world.centerX-55, game.world.centerY+20, gameOver_score);
        gameOver_score_image.anchor.set(0.5, 1);


    gameOver_highScore = game.add.retroFont('undo_100', 12, 16, Phaser.RetroFont.TEXT_SET1, 10, 0, 0);
    gameOver_highScore.multiLine = true;
    gameOver_highScore.text = "high:\n"+highScore;
        gameOver_highScore_image = game.add.image(game.world.centerX+55, game.world.centerY+20, gameOver_highScore);
        gameOver_highScore_image.anchor.set(0.5, 1);


    var highScoreDisplay = highScore;
    if(currentScore > highScore) {
        highScore = currentScore;
    }

    gameOverDisplayTimer = window.setTimeout(function() {
        highScoreCounter = window.setInterval(function () {
            if (highScoreDisplay >= highScore) {
                window.clearInterval(highScoreCounter);
            } else {
                highScoreDisplay++;
                gameOver_highScore.text = "high:\n" + highScoreDisplay;
            }
        }, 100);

        gameOver_instructions = game.add.retroFont('undo_50', 6, 8, Phaser.RetroFont.TEXT_SET1, 10, 0, 0);
        gameOver_instructions.multiLine = true;
            gameOver_instructions.text = " ( press up )";
            gameOver_instructions_image = game.add.image(game.world.centerX, game.world.centerY+40, gameOver_instructions);
            gameOver_instructions_image.anchor.set(0.5, 1);

            gameState = gameState_gameOver;

    }, 1000);
}

function createPlayer(){
    player = game.add.sprite(playerStartX*8, playerStartY*8, 'player', 0, gameGroup);
    player.z = 10;

    player.gravityValue = 6;
    game.physics.enable( [ player ], Phaser.Physics.P2JS, false);
    player.body.fixedRotation = true;

    player.playersensor_up = player.body.addRectangle(player.width-2,4,0,-player.height/2);
    player.playersensor_up.sensor=true;
    player.playersensor_down = player.body.addRectangle(player.width-2,4,0,player.height/2);
    player.playersensor_down.sensor=true;


    player.playersensor_left = player.body.addRectangle(1,player.height-10, -player.width/2,0 +1);
    player.playersensor_left.sensor=true;

    player.playersensor_right = player.body.addRectangle(1,player.height-10, player.width/2,0 -1);
    player.playersensor_right.sensor=true;

    player.groundContacts = 0;
    player.wall_leftContacts = 0;
    player.wall_rightContacts = 0;

    player.body.onBeginContact.add(playerCollide,this);
    player.body.onEndContact.add(playerCollideEnd,this);
    player.body.setMaterial(playerMaterial, true, true, true, true);

    setupSpikesCallback();
}

function setupSpikesCallback(){

    for(var i=0; i<spikes.length; i++) {
        spikes[i].body.createBodyCallback(player, spikesHit, this);
    }
}

var brickSpawner;
var cealingAdder;
function setupTimedSpawning(){

    var i=spacesX;

    refreshCealing(cealingAt);

    brickSpawner = window.setInterval(function(){

        if(runSpawaner && player != null) {
            i -= spawnRandomBrickSet(i, cealingAt);
            if (i < 1) {
                clearInterval(brickSpawner);

                if (cealingAt + 4 < spacesY) {
                    cealingAdder = window.setTimeout(function () {

                        FallingCealing.play();
                        cealingAt++;
                        setupTimedSpawning()
                    }, 1000);
                }
            }
        }
    }, 1000);
}

function setupMaterial(mat1, mat2, friction, restitution, stiffness, relaxation, frictionStiffness, frictionRelaxation, surfaceVelocity){

    var material = game.physics.p2.createContactMaterial(mat1, mat2);

    material.friction = friction;     // Friction to use in the contact of these two materials.
    material.restitution = restitution;  // Restitution (i.e. how bouncy it is!) to use in the contact of these two materials.
    material.stiffness = stiffness;    // Stiffness of the resulting ContactEquation that this ContactMaterial generate.
    material.relaxation = relaxation;     // Relaxation of the resulting ContactEquation that this ContactMaterial generate.
    material.frictionStiffness = frictionStiffness;    // Stiffness of the resulting FrictionEquation that this ContactMaterial generate.
    material.frictionRelaxation = frictionRelaxation;     // Relaxation of the resulting FrictionEquation that this ContactMaterial generate.
    material.surfaceVelocity = surfaceVelocity;        // Will add surface velocity to this material. If bodyA rests on top if bodyB, and the surface velocity is positive, bodyA will slide to the right.

    return material;
}

function preGame(){
    currentScore = 0;
    createPlayer();
    gameState = gameState_game;
}

function refreshCealing(cealingPos){

    for(var i=0; i<cealing.length; i++){
        cealing[i].destroy();
    }
    cealing = [];

    for(var i=0; i<spacesX; i++){
        for(var j=0; j<cealingPos; j++){
            var bl = game.add.sprite(i*8,j*8, 'blackBrick', 0, gameGroup);
            bl.z = 10;
            //you don't need a physics body!
            cealing.push(bl);
        }

        var spike = game.add.sprite(i*8,cealingPos*8+4, 'spikeDown', 0, gameGroup);
        spike.z = 10;
        game.physics.p2.enable(spike, false);
        spike.body.static = true;

        if(player != null) {
            spike.body.createBodyCallback(player, spikesHit, this);
        }

        spike.body.setMaterial(blockMaterial, true, true, true, true);
        cealing.push(spike);
    }

    gameGroup.sort('z', Phaser.Group.SORT_ASCENDING);
}

function createPlayfield(withPlayer){

    for(var i=0; i<spacesX; i++){
        var spike = game.add.sprite(i*8,spacesY*8-4, 'spikeUp', 0, gameGroup);
        spike.z = 10;
        game.physics.p2.enable(spike, false);
        spike.body.static = true;

        //spike.body.createBodyCallback(player, spikesHit, this);
        spike.body.setMaterial(blockMaterial, true, true, true, true);
        spikes.push(spike);

        //blocks.push(spike);
    }

    for(var i=0; i<spacesY; i++) {

        var leftwall = game.add.sprite(0,i*8, 'blackBrick', 0, gameGroup);
        leftwall.z = 10;
        game.physics.p2.enable(leftwall, false);
        leftwall.body.static = true;
        //leftwall.body.setMaterial(blockMaterial, true, true, true, true);

        //blocks.push(leftwall);

        var rightwall = game.add.sprite(spacesX*8,i*8, 'blackBrick', 0, gameGroup);
        rightwall.z = 10;
        game.physics.p2.enable(rightwall, false);
        rightwall.body.static = true;

        //rightwall.body.setMaterial(blockMaterial, true, true, true, true);
        //blocks.push(rightwall);

        if(i == spacesY-3){

            for(var j=0; j<spacesX; j++) {

                if (j < 4 || j > spacesX - 4 || (j > 14 && j < 18)) {

                    var platform = game.add.sprite(j * 8, i * 8, 'blackBrick', 0, gameGroup);
                    platform.z = 10;
                    game.physics.p2.enable(platform, false);
                    platform.body.static = true;
                    //platform.body.setMaterial(blockMaterial, true, true, true, true);
                    //blocks.push(platform);
                }
            }
        }
    }
}

var deleteBlipsTimer = null;
function update() {

    scoreText.setText(""+currentScoreDisplay);
    if(currentScoreDisplay < currentScore){
        currentScoreDisplay++;
    }

    //GAME STATE START - PLAYER EXISTS
    switch (gameState) {

        case gameState_titleScreen:
            titleScreen();
            break;
        case gameState_game:
            runGame();
            break;
        case gameState_preGame:
            preGame();
            break;
        case gameState_gameOver_setup:
            gameOverSetup();
            break;
        case gameState_gameOver:
            gameOver();
            break;
        case gameState_cleanUp:
            cleanUp();
            break;
        case gameState_postCleanup:
            waitForTitleScreen();
            break;
        default:
            break;
    }
}

function titleScreen(){

    if(leftButton.isDown || rightButton.isDown || jumpButton.isDown || actionButton.isDown){
        title_image.destroy();
        instructions_image.destroy();

        gameState = gameState_preGame;
    }
}

function waitForTitleScreen(){

    if(leftButton.isUp && rightButton.isUp && jumpButton.isUp && actionButton.isUp){

        gameState = gameState_titleScreen;

    }
}

function gameOver(){

    if(leftButton.isDown || rightButton.isDown || jumpButton.isDown || actionButton.isDown){

        gameOver_title.destroy();
        gameOver_score.destroy();
        gameOver_highScore.destroy();

        if(gameOver_instructions) {
            gameOver_instructions.destroy();
        }

        title_image.destroy();
        instructions_image.destroy();
        gameOver_title_image.destroy();
        gameOver_score_image.destroy();
        gameOver_highScore_image.destroy();

        if(gameOver_instructions_image) {
            gameOver_instructions_image.destroy();
        }

        gameState = gameState_cleanUp;
    }
}

function cleanUp()
{
    for(var i=0; i<blips.length; i++){
        blips[i].destroy();
    }

    spikes = [];
    blips = [];
    var ch = blocksGroup.children;
    for(var i=0; i<ch.length; i++){
        ch[i].destroy();
    }

    gameGroup.destroy(true);
    clearTimeout(gameOverDisplayTimer);
    clearInterval(highScoreCounter);
    clearInterval(brickSpawner);
    clearTimeout(cealingAdder);
    currentScore = 0;
    currentScoreDisplay = 0;

    cealingAt = 0;
    create();

    gameState = gameState_postCleanup;
}

function gameOverSetup(){

    scoreText.destroy();
    score_image.destroy();

    addGameOverText();
    gameState = gameState_gameOver_wait;
}

function runGame(){

    //for now...
    if (deleteBlipsTimer == null && blips.length > 2) {

        window.setTimeout(function () {

            if (cealingAt > -1) {
                cealingAt--;
                levelClear.play();

                if (blips[0] && blips[1] && blips[2]) {
                    if (blips[0].color == blips[1].color && blips[0].color == blips[2].color) {
                        if (cealingAt > -1) {
                            cealingAt--;

                            currentScore += 1;
                        }
                    } else {

                        //currentScore+=5;
                    }
                }
            }

            refreshCealing(cealingAt);
        }, 750);

        //delay the deleting of the blips
        //heh... this is STUPID
        deleteBlipsTimer = window.setTimeout(function () {
            blips[0].destroy();
            deleteBlipsTimer = window.setTimeout(function () {
                blips[1].destroy();
                deleteBlipsTimer = window.setTimeout(function () {
                    blips[2].destroy();
                    blips = [];
                    deleteBlipsTimer = null;

                }, 250);
            }, 250);
        }, 250);
    }

    for (var i = 0; i < deleteQueue.length; i++) {
        deleteQueue[i].destroy(true);

        if (deleteQueue[i] == player) {
            player = null;
            gameState = gameState_gameOver_setup;
            playerHit.play();
        }
    }

    if(player != null) {

        if(player.wall_leftContacts > 0){
            player.body.x += 0.5;
        }

        if(player.wall_rightContacts > 0){
            player.body.x -= 0.5;
        }

        //move ya
        if (leftButton.isDown && player.wall_leftContacts <= 0) {
            leftDown = true
        } else if (leftButton.isUp) {
            leftDown = false;
        }

        if (rightButton.isDown && player.wall_rightContacts <= 0) {
            rightDown = true;
        } else if (rightButton.isUp) {
            rightDown = false;
        }

        if(jumpButton.isDown && onGround(player) && jumpTimer < Date.now() && jumpReleased) {
            jumpDown = true;
            jumpTimer = Date.now() + 10;
            jumpReleased = false;
            Jump.play();

        } else if(jumpButton.isUp) {
            jumpDown = false;
            jumpTimer = Date.now() + 10;
            jumpReleased = true;        }


            if (leftDown) {
            if (player.body.velocity.x > -90) {
                player.body.velocity.x -= 10;
            }
        } else if (rightDown) {
            if (player.body.velocity.x < 90) {
                player.body.velocity.x += 10;
            }
        } else {
            player.body.velocity.x = 0;
        }

        var f = -30;
        var m_f = -120;
        if (jumpDown && player.body.velocity.y+f > m_f ) {
            player.body.velocity.y += f;
        } else {
            jumpDown = false;
        }
    }
}

function updateGravity(object){
    if(object.gravityValue){
        object.body.velocity.y += object.gravityValue;
    }
}

function spawnRandomBrickSet( xPos, yPos ){


    var brickType = fallingBrickTypes[Math.floor( Math.random() * fallingBrickTypes.length )];
    var width = brickType[0];
    var height = brickType[1];
    var brickData = brickType[2];
    var brickSprite = brickType[3];
    var color = brickType[4];

    if(height == 1){
        yPos++;
    }

    if(width == 2){
        xPos-=(width+1)
    } else {
        xPos -= width;
    }

    if(xPos < 2){ return 999; } //fuck off!

    var returnWidth = width;

    var brick = game.add.sprite((xPos*8),(height*8)+(yPos*8), 'empty', 0, blocksGroup);
    brick.z = 10;

    game.physics.p2.enable(brick, false);
    brick.body.clearShapes();

    var firstX = -1;
    var firstY = -1;

    var lastX = -1;
    var lastY = -1;

    //HOLY FUCK!
    for(var x=0; x<width; x++){
        for(var y=0; y<height; y++){

            var index = y*height+x; //right?

            if(brickData[index] == 1) {
                lastX = x;
                lastY = y;
            }
        }
    }

    for(var x=0; x<width; x++){
        for(var y=0; y<height; y++){

            var index = y*width+x; //right?

            if(brickData[index] == 1) {

                if(firstX == -1) {
                    firstX = x;
                    firstY = y;
                }

                var adjX = 4;
                var adjY = 4;

                var b = brick.addChild(game.make.sprite(x*8-(Math.floor((firstX+lastX)/2)*8)-adjX, y*8-(Math.floor((firstY+lastY)/2)*8)-adjY, brickSprite, 0));
                b.smoothed = false;
            }
        }
    }

    for(var x=0; x<width; x++){
        for(var y=0; y<height; y++){

            var index = y*height+x; //right?

            if(brickData[index] == 1) {
                var r = brick.body.addRectangle(8, 8, (x * 8) - ((Math.floor((firstX+lastX)/2) * 8)), (y * 8) - (Math.floor((firstY+lastY)/2) * 8));
            }
        }
    }


    //	Enable the physics body on this sprite and turn on the visual debugger
    //
    brick.body.angularDamping = 1.0;
    brick.body.damping = 0.1;

    brick.gravityValue = 1.0;
    brick.mass = 10;
    brick.body.fixedRotation = false;
    brick.body.setMaterial(blockMaterial, true, true, true, true);
    brick.body.color = color;

    brick.body.onBeginContact.add(blockCollide, brick.body);
    brick.body.onEndContact.add(blockCollideEnd,this);
    brick.body.sprite = brick;

    blockSpawnIn.play();

    return returnWidth;
}

function onGround(object){
    return((object.groundContacts > 0));
}

function render(){
    pixel.context.drawImage(game.canvas, 0, 0, game.width, game.height, 0, 0, pixel.width, pixel.height);
}

//collision responses
function spikesHit(body1, body2){
    if(body2.sprite == player){

        //KILL THE MOTHERFUCKER!
        deleteQueue.push(player);

    }
}

function blockCollide(bodyA, shapeA, shapeB, contactEquation){

    if(this && this.color && bodyA && bodyA.color) {
        if (this.color == bodyA.color) {

            if(bodyA.sprite && this.sprite) {

                if(deleteQueue.indexOf(bodyA.sprite) === -1) {
                    deleteQueue.push(bodyA.sprite);

                    if(deleteBlipsTimer != null){
                       //if we haven't cleared out the blips yet
                       //from the delay
                       window.clearTimeout(deleteBlipsTimer);
                       for(var i=0; i<blips.length; i++){
                           //this should be safe, because we didn't give this a body
                           blips[i].destroy();
                       }

                       blips = [];
                    }

                    var blipColor = '';
                    if(this.color == 1) {
                        blipColor = 'redPeg';
                    } else if(this.color == 2){
                        blipColor = 'greenPeg';
                    } else if(this.color == 3){
                        blipColor = 'bluePeg';
                    } else if(this.color == 4){
                        blipColor = 'orangePeg';
                    } else if(this.color == 5){
                        blipColor = 'purplePeg';
                    }

                    var sp = game.add.sprite(blips.length*8, 8, blipColor, 0, gameGroup);
                    sp.z = 50;
                    sp.color = this.color;
                    currentScore++;
                    killBlock.play();

                    blips.push(sp);
                }

                if(deleteQueue.indexOf(this.sprite) === -1) {
                    deleteQueue.push(this.sprite);
                }
            }
        }
    }
}

function blockCollideEnd(bodyA,shapeA,shapeB){

}

function playerCollide(bodyA,shapeA,shapeB,contactEquation){

    if(player != null) {
        if (shapeA == player.playersensor_down) {
            player.groundContacts++;
        }

        if(shapeA == player.playersensor_left) {
            player.wall_leftContacts++;
        }

        if(shapeA == player.playersensor_right) {
            player.wall_rightContacts++;
        }

        if (shapeA == player.playersensor_up) {

            //are we fatal?
            if(bodyA != null) {
                if (bodyA.velocity.y > 5) {
                    deleteQueue.push(player);
                }
            }
        }
     }
}

function playerCollideEnd(bodyA,shapeA,shapeB){

    if(player != null) {
        if (shapeA == player.playersensor_down) {
            player.groundContacts--;
        }

        if(shapeA == player.playersensor_left) {
            player.wall_leftContacts--;
        }

        if(shapeA == player.playersensor_right) {
            player.wall_rightContacts--;
        }
    }
}

function blockContact(body, shape1, shape2, data){

}

function blockEndContact(body, shape1, shape2){


}



